import processing.serial.*;

import eeml.*;

import ddf.minim.*;
import ddf.minim.signals.*;

Minim minim;
AudioOutput out;
SineWave sqa;

float myValue;

float spin = 0;

float xmag, ymag = 0;
float newXmag, newYmag = 0; 

DataIn dIn;

void setup()
{
  size(640, 380, P3D); 
  noStroke(); 
  colorMode(RGB, 1); 
    //println(Arduino.list());
    //arduino = new Arduino(this, Arduino.list()[0], 115200);    
    dIn = new DataIn(this, "[yourfeed]", "[your key]", 8000);
    minim = new Minim(this);
  // get a line out from Minim, default sample rate is 44100, bit depth is 16
  
    out = minim.getLineOut(Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sqa = new SineWave(440, 0.5, out.sampleRate());
  
  //out = minim.getLineOut(Minim.MONO, 2048);
 
  //sqa = new SquareWave(440, 0.2, out.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sqa.portamento(200);
  // add the oscillator to the line out
  out.addSignal(sqa);
 
 out.mute();
}

void draw()
{
  
 background(0.5);
  
  pushMatrix(); 
 
  translate(width/2, height/2, -30); 
  
  newXmag = spin/float(width) * TWO_PI;
  newYmag = (myValue * spin)/float(height) * TWO_PI;
  
  float diff = xmag-newXmag;
  if (abs(diff) >  0.01) { xmag -= diff/4.0; }
  
  diff = ymag-newYmag;
  if (abs(diff) >  0.01) { ymag -= diff/4.0; }
  
  rotateX(-ymag); 
  rotateY(-xmag); 
  
  scale(90);
  beginShape(QUADS);

  fill(0, 1, 1); vertex(-1,  1,  1);
  fill(1, 1, 1); vertex( 1,  1,  1);
  fill(1, 0, 1); vertex( 1, -1,  1);
  fill(0, 0, 1); vertex(-1, -1,  1);

  fill(1, 1, 1); vertex( 1,  1,  1);
  fill(1, 1, 0); vertex( 1,  1, -1);
  fill(1, 0, 0); vertex( 1, -1, -1);
  fill(1, 0, 1); vertex( 1, -1,  1);

  fill(1, 1, 0); vertex( 1,  1, -1);
  fill(0, 1, 0); vertex(-1,  1, -1);
  fill(0, 0, 0); vertex(-1, -1, -1);
  fill(1, 0, 0); vertex( 1, -1, -1);

  fill(0, 1, 0); vertex(-1,  1, -1);
  fill(0, 1, 1); vertex(-1,  1,  1);
  fill(0, 0, 1); vertex(-1, -1,  1);
  fill(0, 0, 0); vertex(-1, -1, -1);

  fill(0, 1, 0); vertex(-1,  1, -1);
  fill(1, 1, 0); vertex( 1,  1, -1);
  fill(1, 1, 1); vertex( 1,  1,  1);
  fill(0, 1, 1); vertex(-1,  1,  1);

  fill(0, 0, 0); vertex(-1, -1, -1);
  fill(1, 0, 0); vertex( 1, -1, -1);
  fill(1, 0, 1); vertex( 1, -1,  1);
  fill(0, 0, 1); vertex(-1, -1,  1);

  endShape();
  
  popMatrix(); 
  
   println(myValue);
   //arduino.analogWrite(9,myValue);
   
}

void onReceiveEEML(DataIn d){  
    
   myValue = d.getValue(0); 
    //myValue = int(remoteValue);
    
   spin = myValue * random(50);

   sqa.setFreq(myValue);
 
   out.unmute();
 
   delay(500);
 
   out.mute();

}

void stop()
{
  out.close();
  minim.stop();
  
  super.stop();
}
